<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" />
    <title>Product API</title>

    <link rel="stylesheet" href="/css/bootstrap.min.css">

</head>

<body class="bg-light">
    <nav class="navbar navbar-expand-lg navbar-light bg-white border-bottom">
        <a class="navbar-brand" href="#">Point of Sale</a>
    </nav>
    <div class="container-fluid">
        <div class="row" style="min-height: 93.8vh">
            <div class="col-md-2 bg-white shadow">
                <div class="list-group mt-3">
                    <a href="/category/index" class="list-group-item list-group-item-action">Category</a>
                    <a href="/variant/index" class="list-group-item list-group-item-action ">Variant</a>
                    <a href="/product/index" class="list-group-item list-group-item-action active">Product</a>
                    <a href="/orderheader/index" class="list-group-item list-group-item-action">Order header</a>
                    <a href="/orderdetail/index" class="list-group-item list-group-item-action">Order detail</a>
                </div>
            </div>
            <div class="col-md-10">
                <div class="card mt-3">
                    <div class="card-body shadow">
                        <h2>Product API</h2>
                        <p>
                            <button class="btn btn-primary" onclick="OpenList(0, 5)">Open List</button>
                            <button class="btn btn-primary" onclick="OpenForm()">Open Add Form</button>
                        </p>
                        <input class="form-control" type="text" placeholder="Search" onkeyup="SearchProduct(this.value)" autocomplete="off">
                        <div id="productList"></div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <script src="/js/jquery-3.5.1.min.js"></script>
    <script src="/js/bootstrap-bundle.min.js"></script>

    <script>
        function OpenList(currentPage, length) {
            $.ajax({
                url: '/api/productmapped?page=' + currentPage + '&size=' + length,
                type: 'GET',
                contentType: 'application/json',
                success: function(data) {
                    let table = '<select class="custom-select mt-3" id="size" onchange="OpenList(0,this.value)">'
                    table += '<option value="3" selected>..</option>'
                    table += '<option value="5">5</option>'
                    table += '<option value="10">10</option>'
                    table += '<option value="15">15</option>'
                    table += '</select>'
                    table += '<table class="table table-hover">';
                    table += "<tr> <th width='10%' class='text-center'>#</th> <th>Variant Name</th> <th>Product Initial</th> <th>Product Name</th> <th>Product Description</th> <th>Product Price</th> <th>Product Stock</th> <th>Action</th> </tr>"
                    for (let i = 0; i < data.product.length; i++) {
                        table += "<tr>";
                        table += "<td class='text-center'>" + (i + 1) + "</td>";
                        table += "<td>" + data.product[i].variant.variantName + "</td>";
                        table += "<td>" + data.product[i].productInitial + "</td>";
                        table += "<td>" + data.product[i].productName + "</td>";
                        table += "<td>" + data.product[i].productDescription + "</td>";
                        table += "<td>" + data.product[i].productPrice + "</td>";
                        table += "<td>" + data.product[i].productStock + "</td>";
                        table += "<td><button class='btn btn-primary' value='" + data.product[i].id + "' onclick='formEdit(this.value)'>Edit</button> <button class='btn btn-danger' value='" + data.product[i].id + "' onclick='formDelete(this.value)'>Delete</button> </td>";
                        table += "</tr>";
                    }
                    table += "</table>";
                    table += "<br>"
                    table += '<nav aria-label="Page navigation">';
                    table += '<ul class="pagination">'
                    table += '<li class="page-item"><a class="page-link" onclick="OpenList(' + (data.currentPage - 1) + ',' + length + ')">Previous</a></li>'
                    let index = 1;
                    for (let i = 0; i < data.totalPages; i++) {
                        table += '<li class="page-item"><a id="pageslink" class="page-link" onclick="OpenList(' + i + ',' + length + ')">' + index + '</a></li>'
                        index++;
                    }
                    table += '<li class="page-item"><a class="page-link" onclick="OpenList(' + (data.currentPage + 1) + ',' + length + ')">Next</a></li>'
                    table += '</ul>'
                    table += '</nav>';
                    $('#productList').html(table);
                }
            });
        }

        function OpenForm() {
            $.ajax({
                url: '/api/category',
                type: 'GET',
                contentType: 'application/json',
                success: function(category) {
                    let form = "<table class='table table-bordered'>"
                    form += "<tr>"
                    form += "<td>Category </td>"
                    form += "<td><select class='custom-select' id='category_id'>"
                    form += "<option>Category</option>"
                    for (let i = 0; i < category.length; i++) {
                        form += "<option value='" + category[i].id + "'>" + category[i].categoryName + "</option>"
                    }
                    form += "</select></td>"
                    form += "</tr>"
                    form += "<tr>"
                    form += "<td>Variant </td>"
                    form += "<td><select class='custom-select variantID' id='variant_id'>"
                    form += "<option>Variant</option>"
                    form += "</select></td>"
                    form += "</tr>"
                    form += "<tr>"
                    form += "<td>Product Initial </td>"
                    form += "<td><input class='form-control' type='text' id='product_initial'></td>"
                    form += "</tr>"
                    form += "<tr>"
                    form += "<td>Product Name </td>"
                    form += "<td><input class='form-control' type='text' id='product_name'></td>"
                    form += "</tr>"
                    form += "<tr>"
                    form += "<td>Product Description </td>"
                    form += "<td><textarea rows='5' class='form-control' id='product_description'></textarea></td>"
                    form += "</tr>"
                    form += "<tr>"
                    form += "<td>Product Price </td>"
                    form += "<td><input class='form-control' type='text' id='product_price'></td>"
                    form += "</tr>"
                    form += "<tr>"
                    form += "<td>Product Stock </td>"
                    form += "<td><input class='form-control' type='text' id='product_stock'></td>"
                    form += "</tr>"
                    form += "<td colspan='2'> <button class='btn btn-primary' onclick='SaveProduct()'>Save</button> </td>"
                    form += "</tr>"
                    form += "</table>"

                    $('#productList').html(form)

                    $("#category_id").change(function() {
                        let idCategory = $("#category_id").val()
                            //console.log(idCategory)

                        $.ajax({
                            url: '/api/variantbycategory/' + idCategory,
                            type: 'GET',
                            contentType: 'application/json',
                            success: function(variant) {
                                //console.log(variant)
                                let select = ''
                                for (let i = 0; i < variant.length; i++) {
                                    select += "<option value='" + variant[i].id + "'>" + variant[i].variantName + "</option>"
                                }
                                $('.variantID').html(select);
                            }
                        });

                    });
                }
            });
        }

        function SaveProduct() {
            var formData = '{';
            formData += '"variantId":"' + $('#variant_id').val() + '",';
            formData += '"productInitial":"' + $('#product_initial').val() + '",';
            formData += '"productName":"' + $('#product_name').val() + '",';
            formData += '"productDescription":"' + $('#product_description').val() + '",';
            formData += '"productPrice":"' + $('#product_price').val() + '",';
            formData += '"productStock":"' + $('#product_stock').val() + '"';
            formData += '}';

            $.ajax({
                url: '/api/product',
                type: 'post',
                contentType: 'application/json',
                data: formData,
                success: function(data) {
                    OpenList(0, 5);
                }
            });
        }

        function formEdit(id) {
            $.ajax({
                url: '/api/product/' + id,
                type: 'GET',
                contentType: 'application/json',
                success: function(product) {
                    let form = "<table class='table table-bordered'>"
                    form += "<tr>"
                    $.ajax({
                        url: '/api/category/',
                        type: 'GET',
                        contentType: 'application/json',
                        success: function(category) {
                            form += "<td>Category </td>"
                            form += "<td><select class='custom-select' id='category_id'>"
                            for (let i = 0; i < category.length; i++) {
                                if (category[i].id == product.variant.categoryId) {
                                    selected = "selected"
                                } else {
                                    selected = ""
                                }
                                form += "<option value='" + category[i].id + "' " + selected + ">" + category[i].categoryName + "</option>"
                            }
                            form += "</select></td>"
                            form += "</tr>"
                            form += "<tr>"
                            form += "<td>Variant </td>"
                            form += "<td><select class='custom-select variantID' id='variant_id'>"

                            $.ajax({
                                url: '/api/variantbycategory/' + product.variant.categoryId,
                                type: 'GET',
                                contentType: 'application/json',
                                success: function(dataVariant) {
                                    for (let i = 0; i < dataVariant.length; i++) {
                                        if (dataVariant[i].id == product.variantId) {
                                            selected = "selected"
                                        } else {
                                            selected = ""
                                        }
                                        form += "<option value='" + dataVariant[i].id + "' " + selected + ">" + dataVariant[i].variantName + "</option>"
                                    }


                                    form += "</select></td>"
                                    form += "</tr>"
                                    form += "<tr>"
                                    form += "<td>Product Initial </td>"
                                    form += "<td><input class='form-control' type='text' id='product_initial' value='" + product.productInitial + "'><input class='form-control' type='hidden' id='createdBy' value='" + product.createdBy + "'></td>"
                                    form += "</tr>"
                                    form += "<tr>"
                                    form += "<td>Product Name </td>"
                                    form += "<td><input class='form-control' type='text' id='product_name' value='" + product.productName + "'><input class='form-control' type='hidden' id='createdOn' value='" + product.createdOn + "'></td>"
                                    form += "</tr>"
                                    form += "<tr>"
                                    form += "<td>Product Description </td>"
                                    form += "<td><textarea rows='5' class='form-control' id='product_description'>" + product.productDescription + "</textarea></td>"
                                    form += "</tr>"
                                    form += "<tr>"
                                    form += "<td>Product Price </td>"
                                    form += "<td><input class='form-control' type='text' id='product_price' value='" + product.productPrice + "'></td>"
                                    form += "</tr>"
                                    form += "<tr>"
                                    form += "<td>Product Stock </td>"
                                    form += "<td><input class='form-control' type='text' id='product_stock' value='" + product.productStock + "'></td>"
                                    form += "</tr>"
                                    form += "<td colspan='2'> <button value='" + product.id + "' class='btn btn-primary' onclick='UpdateProduct(this.value)'>Save</button> </td>"
                                    form += "</tr>"
                                    form += "</table>"

                                    $('#productList').html(form)

                                    let idCategory = product.variant.categoryId

                                    $("#category_id").change(function() {
                                        idCategory = $("#category_id").val()
                                            // console.log(idCategory)

                                        $.ajax({
                                            url: '/api/variantbycategory/' + idCategory,
                                            type: 'GET',
                                            contentType: 'application/json',
                                            success: function(variant) {
                                                // console.log(variant)
                                                let select = ''
                                                for (let i = 0; i < variant.length; i++) {
                                                    if (variant[i].id == product.variantId) {
                                                        selected = "selected"
                                                    } else {
                                                        selected = ""
                                                    }
                                                    select += "<option value='" + variant[i].id + "' " + selected + ">" + variant[i].variantName + "</option>"
                                                }
                                                $('.variantID').html(select);
                                            }
                                        });

                                    });
                                }
                            });
                        }
                    });
                }
            });
        }

        function UpdateProduct(id) {
            var formData = '{';
            formData += '"variantId":"' + $('#variant_id').val() + '",';
            formData += '"productInitial":"' + $('#product_initial').val() + '",';
            formData += '"productName":"' + $('#product_name').val() + '",';
            formData += '"productDescription":"' + $('#product_description').val() + '",';
            formData += '"productPrice":"' + $('#product_price').val() + '",';
            formData += '"productStock":"' + $('#product_stock').val() + '",';
            formData += '"createdBy":"' + $('#createdBy').val() + '",'
            formData += '"createdOn":"' + $('#createdOn').val() + '"'
            formData += '}';

            $.ajax({
                url: '/api/product/' + id,
                type: 'put',
                contentType: 'application/json',
                data: formData,
                success: function(data) {
                    OpenList(0, 5);
                }
            });
        }

        function formDelete(id) {
            $.ajax({
                url: '/api/product/' + id,
                type: 'GET',
                contentType: 'application/json',
                success: function(product) {
                    // console.log(product)

                    let form = "<table class='table table-bordered'>"
                    form += "<tr>"
                    $.ajax({
                        url: '/api/category/',
                        type: 'GET',
                        contentType: 'application/json',
                        success: function(category) {
                            form += "<td>Category </td>"
                            form += "<td><select class='custom-select' id='category_id' disabled>"
                            for (let i = 0; i < category.length; i++) {
                                if (category[i].id == product.variant.categoryId) {
                                    selected = "selected"
                                } else {
                                    selected = ""
                                }
                                form += "<option value='" + category[i].id + "' " + selected + ">" + category[i].categoryName + "</option>"
                            }
                            form += "</select></td>"
                            form += "</tr>"
                            form += "<tr>"
                            form += "<td>Variant </td>"
                            form += "<td><select class='custom-select variantID' id='variant_id' disabled>"

                            $.ajax({
                                url: '/api/variantbycategory/' + product.variant.categoryId,
                                type: 'GET',
                                contentType: 'application/json',
                                success: function(dataVariant) {
                                    console.log(product.variant.categoryId)
                                    for (let i = 0; i < dataVariant.length; i++) {
                                        if (dataVariant[i].id == product.variantId) {
                                            selected = "selected"
                                        } else {
                                            selected = ""
                                        }
                                        form += "<option value='" + dataVariant[i].id + "' " + selected + ">" + dataVariant[i].variantName + "</option>"
                                    }

                                    form += "</select></td>"
                                    form += "</tr>"
                                    form += "<tr>"
                                    form += "<td>Product Initial </td>"
                                    form += "<td><input class='form-control' type='text' id='product_name' value='" + product.productInitial + "' disabled><input class='form-control' type='hidden' id='createdBy' value='" + product.createdBy + "' disabled></td>"
                                    form += "</tr>"
                                    form += "<tr>"
                                    form += "<td>Product Name </td>"
                                    form += "<td><input class='form-control' type='text' id='product_name' value='" + product.productName + "' disabled><input class='form-control' type='hidden' id='createdOn' value='" + product.createdOn + "' disabled></td>"
                                    form += "</tr>"
                                    form += "<tr>"
                                    form += "<td>Product Description </td>"
                                    form += "<td><textarea rows='5' class='form-control' id='product_description' disabled>" + product.productDescription + "</textarea></td>"
                                    form += "</tr>"
                                    form += "<tr>"
                                    form += "<td>Product Price </td>"
                                    form += "<td><input class='form-control' type='text' id='product_price' value='" + product.productPrice + "' disabled></td>"
                                    form += "</tr>"
                                    form += "<tr>"
                                    form += "<td>Product Stock </td>"
                                    form += "<td><input class='form-control' type='text' id='product_stock' value='" + product.productStock + "' disabled></td>"
                                    form += "</tr>"
                                    form += "<td colspan='2'> <button value='" + product.id + "' class='btn btn-danger' onclick='DeleteProduct(this.value)'>Delete</button> </td>"
                                    form += "</tr>"
                                    form += "</table>"

                                    $('#productList').html(form)

                                    let idCategory = product.variant.categoryId

                                    $("#category_id").change(function() {
                                        idCategory = $("#category_id").val()
                                            // console.log(idCategory)

                                        $.ajax({
                                            url: '/api/variantbycategory/' + idCategory,
                                            type: 'GET',
                                            contentType: 'application/json',
                                            success: function(variant) {
                                                // console.log(variant)
                                                let select = ''
                                                for (let i = 0; i < variant.length; i++) {
                                                    if (variant[i].id == product.variantId) {
                                                        selected = "selected"
                                                    } else {
                                                        selected = ""
                                                    }
                                                    select += "<option value='" + variant[i].id + "' " + selected + ">" + variant[i].variantName + "</option>"
                                                }
                                                $('.variantID').html(select);
                                            }
                                        });

                                    });
                                }
                            });
                        }
                    });
                }
            });
        }

        function DeleteProduct(id) {
            var formData = '{';
            formData += '"variantId":"' + $('#variant_id').val() + '",';
            formData += '"productInitial":"' + $('#product_initial').val() + '",';
            formData += '"productName":"' + $('#product_name').val() + '",';
            formData += '"productDescription":"' + $('#product_description').val() + '",';
            formData += '"productPrice":"' + $('#product_price').val() + '",';
            formData += '"productStock":"' + $('#product_stock').val() + '",';
            formData += '"createdBy":"' + $('#createdBy').val() + '",'
            formData += '"createdOn":"' + $('#createdOn').val() + '"'
            formData += '}';

            $.ajax({
                url: '/api/product/' + id,
                type: 'delete',
                contentType: 'application/json',
                data: formData,
                success: function(data) {
                    OpenList(0, 5);
                }
            });
        }

        function SearchProduct(request) {
            //console.log(request)

            if (request.length > 0) {
                $.ajax({
                    url: '/api/searchproduct/' + request,
                    type: 'GET',
                    contentType: 'application/json',
                    success: function(result) {
                        //console.log(result)
                        let table = '<table class="table table-hover">';
                        table += "<tr> <th width='10%' class='text-center'>#</th> <th>Variant Name</th> <th>Product Initial</th> <th>Product Name</th> <th>Product Description</th> <th>Product Price</th> <th>Product Stock</th> <th>Action</th> </tr>"
                        for (let i = 0; i < result.length; i++) {
                            table += "<tr>";
                            table += "<td class='text-center'>" + (i + 1) + "</td>";
                            table += "<td>" + result[i].variant.variantName + "</td>";
                            table += "<td>" + result[i].productInitial + "</td>";
                            table += "<td>" + result[i].productName + "</td>";
                            table += "<td>" + result[i].productDescription + "</td>";
                            table += "<td>" + result[i].productPrice + "</td>";
                            table += "<td>" + result[i].productStock + "</td>";
                            table += "<td><button class='btn btn-primary' value='" + result[i].id + "' onclick='formEdit(this.value)'>Edit</button> <button class='btn btn-danger' value='" + result[i].id + "' onclick='formDelete(this.value)'>Delete</button> </td>";
                            table += "</tr>";
                        }
                        table += "</table>";
                        $('#productList').html(table);
                    }
                });
            } else {
                OpenList(0, 5);
            }
        }
    </script>
</body>

</html>